package com.gmei.bean.ml;


import java.util.Date;

/**
 * ClassName: MlPreciseExposureBean
 * TableName: ML_C_ET_PE_PRECISEEXPOSURE_DIMEN_D_RT
 * Function:
 * Reason: ML层精准曝光BEAN类
 * Date: 2019/12/3 下午5:07
 *
 * @author liuzhe
 * @since JDK 1.8
 */

/*
  get_json_object(result_card,"$.card_id") as card_id, --卡片id
  get_json_object(result_card,"$.card_content_type") as card_content_type, --卡片内容类型
  get_json_object(result_card,"$.card_type") as card_type, --卡片类型
  get_json_object(result_card,"$.transaction_type") as transaction_type, --卡片业务类型
  get_json_object(result_card,"$.absolute_position") as absolute_position, --绝对位置
  get_json_object(result_card,"$.relative_position") as relative_position, --相对位置
  get_json_object(result_card,"$.filter_f") as filter_f,
  get_json_object(result_card,"$.is_cpc") as is_cpc, --是否为cpc收费卡片
  get_json_object(result_card,"$.cpc_referer") as cpc_referer, --cpc_referer
  get_json_object(result_card,"$.in_page_pose ") as in_page_pose,
  get_json_object(result_card,"$.result_status") as result_status, --结果状态
  get_json_object(result_card,"$.sec_tab_name") as sec_tab_name, --二级页面名称
  --非正常卡片通用参数（banner 豆腐块 icon）
  get_json_object(result_card,"$.module_id") as module_id, --模块id
  get_json_object(result_card,"$.card_name ") as card_name, --卡片名字
  get_json_object(result_card,"$.url") as url, --跳转链接
  --豆腐块额外参数
  get_json_object(result_card,"$.module_type") as module_type, --模块类型
  get_json_object(result_card,"$.grid") as grid, --区域 （a、b、c、d，目前线上最多四张图片）
  --icon的额外参数
  get_json_object(result_card,"$.total_position") as total_position,--总共有几屏
  get_json_object(result_card,"$.current_position") as current_position --icon在第几屏
*/
public class MlPreciseExposureBean {

    private Date day_id;
//    private String gm_nginx_timestamp;
//    private String create_timestamp;
    private String user_id;
    private String action;
//    private String action_name; //匹配码表DIM_ACTION_TYPE(只有两种不需要关联)
    private String page_code;
    private String page_name; //匹配码表DIM_PAGE_TYPE

    private String tab_name;
    private String business_id;
    private String referrer_code;
    private String referrer_name; //匹配码表DIM_PAGE_TYPE
    private String referrer_id;

    private String card_id;
    private String card_name;
    private String card_content_type;
    private String card_content_type_name; //匹配码表DIM_CARD_CONTENT_TYPE
    private String card_type;
    private String card_type_name; //匹配码表DIM_CARD_TYPE
    private String is_cpc;
    private String cpc_referer;
//    private String absolute_position;
//    private String relative_position;
    private String transaction_type;
    private String transaction_type_name; //匹配码表DIM_TRANSACTION_TYPE

    private String filter;
    private String query;
//    private String app_grey_type;
//    private String app_channel;
    private String app_version;
    private String current_city_id;
    private String current_city_name; //匹配码表DIM_CITY
    private String current_province_id; //匹配码表DIM_CITY
    private String current_province_name; //匹配码表DIM_CITY
    private String current_country_id; //匹配码表DIM_CITY
    private String current_country_name; //匹配码表DIM_CITY
    private String current_region_id; //匹配码表DIM_CITY
    private String current_region_name; //匹配码表DIM_CITY

    private String app_code;
    private String device_os_type;
//    private String device_model;
    private String device_id;
//    private String device_android_id;
//    private String device_idfv;
//    private String gm_nginx_time_date;
//    private String create_time_date;
    private String create_time_day;
    private String gm_nginx_time_day;
    private Integer preciseexposure_num;

    public MlPreciseExposureBean() {
    }

    public MlPreciseExposureBean(Date day_id, String user_id, String action, String page_code, String page_name, String tab_name, String business_id, String referrer_code, String referrer_name, String referrer_id, String card_id, String card_name, String card_content_type, String card_content_type_name, String card_type, String card_type_name, String is_cpc, String cpc_referer, String transaction_type, String transaction_type_name, String filter, String query, String app_version, String current_city_id, String current_city_name, String current_province_id, String current_province_name, String current_country_id, String current_country_name, String current_region_id, String current_region_name, String app_code, String device_os_type, String device_id, String create_time_day, String gm_nginx_time_day, Integer preciseexposure_num) {
        this.day_id = day_id;
        this.user_id = user_id;
        this.action = action;
//        this.action_name = action_name;
        this.page_code = page_code;
        this.page_name = page_name;
        this.tab_name = tab_name;
        this.business_id = business_id;
        this.referrer_code = referrer_code;
        this.referrer_name = referrer_name;
        this.referrer_id = referrer_id;
        this.card_id = card_id;
        this.card_name = card_name;
        this.card_content_type = card_content_type;
        this.card_content_type_name = card_content_type_name;
        this.card_type = card_type;
        this.card_type_name = card_type_name;
        this.is_cpc = is_cpc;
        this.cpc_referer = cpc_referer;
        this.transaction_type = transaction_type;
        this.transaction_type_name = transaction_type_name;
        this.filter = filter;
        this.query = query;
//        this.app_channel = app_channel;
        this.app_version = app_version;
        this.current_city_id = current_city_id;
        this.current_city_name = current_city_name;
        this.current_province_id = current_province_id;
        this.current_province_name = current_province_name;
        this.current_country_id = current_country_id;
        this.current_country_name = current_country_name;
        this.current_region_id = current_region_id;
        this.current_region_name = current_region_name;
        this.app_code = app_code;
        this.device_os_type = device_os_type;
        this.device_id = device_id;
        this.create_time_day = create_time_day;
        this.gm_nginx_time_day = gm_nginx_time_day;
        this.preciseexposure_num = preciseexposure_num;
    }

    public Date getDay_id() {
        return day_id;
    }

    public void setDay_id(Date day_id) {
        this.day_id = day_id;
    }

    public String getUser_id() {
        return user_id;
    }

    public void setUser_id(String user_id) {
        this.user_id = user_id;
    }

    public String getAction() {
        return action;
    }

    public void setAction(String action) {
        this.action = action;
    }

//    public String getAction_name() {
//        return action_name;
//    }

//    public void setAction_name(String action_name) {
//        this.action_name = action_name;
//    }

    public String getPage_code() {
        return page_code;
    }

    public void setPage_code(String page_code) {
        this.page_code = page_code;
    }

    public String getPage_name() {
        return page_name;
    }

    public void setPage_name(String page_name) {
        this.page_name = page_name;
    }

    public String getTab_name() {
        return tab_name;
    }

    public void setTab_name(String tab_name) {
        this.tab_name = tab_name;
    }

    public String getBusiness_id() {
        return business_id;
    }

    public void setBusiness_id(String business_id) {
        this.business_id = business_id;
    }

    public String getReferrer_code() {
        return referrer_code;
    }

    public void setReferrer_code(String referrer_code) {
        this.referrer_code = referrer_code;
    }

    public String getReferrer_name() {
        return referrer_name;
    }

    public void setReferrer_name(String referrer_name) {
        this.referrer_name = referrer_name;
    }

    public String getReferrer_id() {
        return referrer_id;
    }

    public void setReferrer_id(String referrer_id) {
        this.referrer_id = referrer_id;
    }

    public String getCard_id() {
        return card_id;
    }

    public void setCard_id(String card_id) {
        this.card_id = card_id;
    }

    public String getCard_name() {
        return card_name;
    }

    public void setCard_name(String card_name) {
        this.card_name = card_name;
    }

    public String getCard_content_type() {
        return card_content_type;
    }

    public void setCard_content_type(String card_content_type) {
        this.card_content_type = card_content_type;
    }

    public String getCard_content_type_name() {
        return card_content_type_name;
    }

    public void setCard_content_type_name(String card_content_type_name) {
        this.card_content_type_name = card_content_type_name;
    }

    public String getCard_type() {
        return card_type;
    }

    public void setCard_type(String card_type) {
        this.card_type = card_type;
    }

    public String getCard_type_name() {
        return card_type_name;
    }

    public void setCard_type_name(String card_type_name) {
        this.card_type_name = card_type_name;
    }

    public String getIs_cpc() {
        return is_cpc;
    }

    public void setIs_cpc(String is_cpc) {
        this.is_cpc = is_cpc;
    }

    public String getCpc_referer() {
        return cpc_referer;
    }

    public void setCpc_referer(String cpc_referer) {
        this.cpc_referer = cpc_referer;
    }

//    public String getAbsolute_position() {
//        return absolute_position;
//    }
//
//    public void setAbsolute_position(String absolute_position) {
//        this.absolute_position = absolute_position;
//    }
//
//    public String getRelative_position() {
//        return relative_position;
//    }
//
//    public void setRelative_position(String relative_position) {
//        this.relative_position = relative_position;
//    }

    public String getTransaction_type() {
        return transaction_type;
    }

    public void setTransaction_type(String transaction_type) {
        this.transaction_type = transaction_type;
    }

    public String getTransaction_type_name() {
        return transaction_type_name;
    }

    public void setTransaction_type_name(String transaction_type_name) {
        this.transaction_type_name = transaction_type_name;
    }

    public String getFilter() {
        return filter;
    }

    public void setFilter(String filter) {
        this.filter = filter;
    }

    public String getQuery() {
        return query;
    }

    public void setQuery(String query) {
        this.query = query;
    }

//    public String getApp_channel() {
//        return app_channel;
//    }

//    public void setApp_channel(String app_channel) {
//        this.app_channel = app_channel;
//    }

    public String getApp_version() {
        return app_version;
    }

    public void setApp_version(String app_version) {
        this.app_version = app_version;
    }

    public String getCurrent_city_id() {
        return current_city_id;
    }

    public void setCurrent_city_id(String current_city_id) {
        this.current_city_id = current_city_id;
    }

    public String getCurrent_city_name() {
        return current_city_name;
    }

    public void setCurrent_city_name(String current_city_name) {
        this.current_city_name = current_city_name;
    }

    public String getCurrent_province_id() {
        return current_province_id;
    }

    public void setCurrent_province_id(String current_province_id) {
        this.current_province_id = current_province_id;
    }

    public String getCurrent_province_name() {
        return current_province_name;
    }

    public void setCurrent_province_name(String current_province_name) {
        this.current_province_name = current_province_name;
    }

    public String getCurrent_country_id() {
        return current_country_id;
    }

    public void setCurrent_country_id(String current_country_id) {
        this.current_country_id = current_country_id;
    }

    public String getCurrent_country_name() {
        return current_country_name;
    }

    public void setCurrent_country_name(String current_country_name) {
        this.current_country_name = current_country_name;
    }

    public String getCurrent_region_id() {
        return current_region_id;
    }

    public void setCurrent_region_id(String current_region_id) {
        this.current_region_id = current_region_id;
    }

    public String getCurrent_region_name() {
        return current_region_name;
    }

    public void setCurrent_region_name(String current_region_name) {
        this.current_region_name = current_region_name;
    }

    public String getApp_code() {
        return app_code;
    }

    public void setApp_code(String app_code) {
        this.app_code = app_code;
    }

    public String getDevice_os_type() {
        return device_os_type;
    }

    public void setDevice_os_type(String device_os_type) {
        this.device_os_type = device_os_type;
    }

    public String getDevice_id() {
        return device_id;
    }

    public void setDevice_id(String device_id) {
        this.device_id = device_id;
    }

    public String getCreate_time_day() {
        return create_time_day;
    }

    public void setCreate_time_day(String create_time_day) {
        this.create_time_day = create_time_day;
    }

    public String getGm_nginx_time_day() {
        return gm_nginx_time_day;
    }

    public void setGm_nginx_time_day(String gm_nginx_time_day) {
        this.gm_nginx_time_day = gm_nginx_time_day;
    }

    public Integer getPreciseexposure_num() {
        return preciseexposure_num;
    }

    public void setPreciseexposure_num(Integer preciseexposure_num) {
        this.preciseexposure_num = preciseexposure_num;
    }

    @Override
    public String toString() {
        return "MlPreciseExposureBean{" +
                "day_id='" + day_id + '\'' +
                ", user_id='" + user_id + '\'' +
                ", action='" + action + '\'' +
                ", page_code='" + page_code + '\'' +
                ", page_name='" + page_name + '\'' +
                ", tab_name='" + tab_name + '\'' +
                ", business_id='" + business_id + '\'' +
                ", referrer_code='" + referrer_code + '\'' +
                ", referrer_name='" + referrer_name + '\'' +
                ", referrer_id='" + referrer_id + '\'' +
                ", card_id='" + card_id + '\'' +
                ", card_name='" + card_name + '\'' +
                ", card_content_type='" + card_content_type + '\'' +
                ", card_content_type_name='" + card_content_type_name + '\'' +
                ", card_type='" + card_type + '\'' +
                ", card_type_name='" + card_type_name + '\'' +
                ", is_cpc='" + is_cpc + '\'' +
                ", cpc_referer='" + cpc_referer + '\'' +
                ", transaction_type='" + transaction_type + '\'' +
                ", transaction_type_name='" + transaction_type_name + '\'' +
                ", filter='" + filter + '\'' +
                ", query='" + query + '\'' +
                ", app_version='" + app_version + '\'' +
                ", current_city_id='" + current_city_id + '\'' +
                ", current_city_name='" + current_city_name + '\'' +
                ", current_province_id='" + current_province_id + '\'' +
                ", current_province_name='" + current_province_name + '\'' +
                ", current_country_id='" + current_country_id + '\'' +
                ", current_country_name='" + current_country_name + '\'' +
                ", current_region_id='" + current_region_id + '\'' +
                ", current_region_name='" + current_region_name + '\'' +
                ", app_code='" + app_code + '\'' +
                ", device_os_type='" + device_os_type + '\'' +
                ", device_id='" + device_id + '\'' +
                ", create_time_day='" + create_time_day + '\'' +
                ", gm_nginx_time_day='" + gm_nginx_time_day + '\'' +
                ", preciseexposure_num=" + preciseexposure_num +
                '}';
    }
}
